# REQUIRED
openapi: 3.0.3

# REQUIRED
info:
  # REQUIRED
  version: '1.2' # added Object Inheritence.
  # REQUIRED
  title: Open API Cource
  # OPTIONAL
  description: 'Spec for Open API cource'
  # OPTIONAL
  contact:
    name: kaushiwould
    email: kaushiwould@gmail.com
    url: www.kaushiwould.com
  # OPTIONAL
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html

# OPTIONAL
servers: # List
# REQUIRED
- url: https://development.gigantic-server.com/v1
  description: Development server
# REQUIRED
- url: https://staging.gigantic-server.com/v1
  description: Staging server
# REQUIRED
- url: https://api.gigantic-server.com/v1
  description: Production server

# REQUIRED
paths:
  /v1/customer:
    get:
      responses:
        200:
          description: List  of Customers
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CustomerList'
                       
  /v1/beers:
    get:
      responses:
        200:
          description: List of Beers
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/BeerList'
    post:
      responses:
        200:
          description: List of Beer2(Inheritence using allof)
          content:
            application/json:
              schema:
                type: object
                # added for Object Inheritence.
                allOf: 
                 - $ref: '#/components/schemas/Beer'
                properties:
                  id:
                    type: number
                    example: 10
                    
                  
                        
# OPTIONAL
# components are reusable, its used with $ref
components: 
  schemas:
    ############################################
    CustomerList:
      type: array
      minItems: 1
      maxItems: 100
      description: List Of Customers
      items:
        $ref: '#/components/schemas/Customer'
    
    ############################################
    Customer:
      #eg for string data type
      #type: string
      #minLength: 2
      #maxLength: 100
      
      #eg for object type
      type: object
      properties: # define json keys
        id:
          type: string
          format: uuid #special format for uuid
        firstname:
          type: string
          minLength: 2
          maxLength: 100
          example: Kaushlendra Singh
        lastname:
          type: string
          minimum: 2
          maxLength: 100
          example: Chauhan
        address:
          $ref: '#/components/schemas/Address'
    ############################################
    Address:    
      type: object
      properties:
        line1: 
          type: string
          example: MI Casa Bela
        line2:
          type: string
          example: wakad
        statecode:
          type: string
          minLength: 1
          maxLength: 100
          description: 2 letters
          # enum
          # way 1 - defining enum
          #enum:
            #- A
            #- B
            #- C
          # way 2 - defining enum
          enum: [A, B, C]
    ############################################
    ############################################
    BeerList:
      type: array
      items:
        $ref: '#/components/schemas/Beer'
    ############################################
    Beer:
      type: object
      properties:
        name:
         type: string
         example: Bira
        style:
          type: string
          enum : [A, B, C, D]
        upc:
          type: string
          format: uuid
        price:
         type: number
         example: 170
        quantity:
          type: number
          example: 12
        brewery:
         $ref: '#/components/schemas/Brewery'
    ############################################
    Brewery:
      type: object
      properties:
        name:
          type: string
          example: Sahara
        location:
          type: string
          example: Wakad, Pune